---
---
<!-- HTML header for doxygen 1.8.10-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>TGUI: include/TGUI/Widgets/Grid.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
<!-- BEGIN CUSTOM 1 -->
<!-- --{{""}}>
{% include head.ext %}
<style>
  div {
    margin-bottom: 0
  }
  #contents {
    padding-left: 0;
    padding-right: 0;
    margin-left: 0;
    margin-right: 0;
    max-width: 1060px;
  }
  address.footer {
    padding-bottom: 1.4em;
  }
</style>
<script type="text/javascript">
function getXPos(item) {
  var x = 0;
  if (item.offsetWidth) {
    while (item && item != document.body && item.id != 'body') {
      x   += item.offsetLeft;
      item = item.offsetParent;
    }
  }
  return x;
}
</script>
<{{""}}!-- -->
<!-- END CUSTOM 1 -->
</head>
<body>
<!-- BEGIN CUSTOM 2 -->
<!-- --{{""}}>
<div id="body" class="NoMargin">
{% include navigation.ext %}
<div id="contents" class="NoMargin">
<{{""}}!-- {% raw %} -->
<!-- END CUSTOM 2 -->
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">TGUI
   &#160;<span id="projectnumber">v0.7-dev</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_380f920385a16f176be7632160138052.html">TGUI</a></li><li class="navelem"><a class="el" href="dir_0bb95f096d007de7ff009a2d5974766c.html">Widgets</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Grid.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">// TGUI - Texus&#39;s Graphical User Interface</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// Copyright (C) 2012-2017 Bruno Van de Velde (vdv_b@tgui.eu)</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">// This software is provided &#39;as-is&#39;, without any express or implied warranty.</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">// In no event will the authors be held liable for any damages arising from the use of this software.</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">// Permission is granted to anyone to use this software for any purpose,</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment">// including commercial applications, and to alter it and redistribute it freely,</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">// subject to the following restrictions:</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">// 1. The origin of this software must not be misrepresented;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">//    you must not claim that you wrote the original software.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment">//    If you use this software in a product, an acknowledgment</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment">//    in the product documentation would be appreciated but is not required.</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">// 2. Altered source versions must be plainly marked as such,</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment">//    and must not be misrepresented as being the original software.</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment">// 3. This notice may not be removed or altered from any source distribution.</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#ifndef TGUI_GRID_HPP</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#define TGUI_GRID_HPP</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#include &lt;TGUI/Container.hpp&gt;</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacetgui.html">tgui</a></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;{</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno"><a class="line" href="classtgui_1_1Grid.html">   38</a></span>&#160;    <span class="keyword">class </span>TGUI_API <a class="code" href="classtgui_1_1Grid.html">Grid</a> : <span class="keyword">public</span> <a class="code" href="classtgui_1_1Container.html">Container</a></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    {</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div><div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="classtgui_1_1Grid.html#ac74ee6eb1b8416abd617a77fd430837f">   42</a></span>&#160;        <span class="keyword">typedef</span> std::shared_ptr&lt;Grid&gt; <a class="code" href="classtgui_1_1Grid.html#ac74ee6eb1b8416abd617a77fd430837f">Ptr</a>; </div><div class="line"><a name="l00043"></a><span class="lineno"><a class="line" href="classtgui_1_1Grid.html#ae5c312f8060724b3e9eacd77a7da0f3c">   43</a></span>&#160;        <span class="keyword">typedef</span> std::shared_ptr&lt;const Grid&gt; <a class="code" href="classtgui_1_1Grid.html#ae5c312f8060724b3e9eacd77a7da0f3c">ConstPtr</a>; </div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno"><a class="line" href="classtgui_1_1Grid.html#a862e75cc54ce2fff46c9590db7f6b5e9">   53</a></span>&#160;        <span class="keyword">enum class</span> <a class="code" href="classtgui_1_1Grid.html#a862e75cc54ce2fff46c9590db7f6b5e9">Alignment</a></div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        {</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;            UpperLeft,   </div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;            Up,          </div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;            UpperRight,  </div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;            Right,       </div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;            BottomRight, </div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;            Bottom,      </div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;            BottomLeft,  </div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;            Left,        </div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;            Center       </div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        };</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        <span class="comment">// Default constructor</span></div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;<span class="comment"></span>        <a class="code" href="classtgui_1_1Grid.html">Grid</a>();</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;        <a class="code" href="classtgui_1_1Grid.html">Grid</a>(<span class="keyword">const</span> <a class="code" href="classtgui_1_1Grid.html">Grid</a>&amp; copy);</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        <a class="code" href="classtgui_1_1Grid.html">Grid</a>&amp; operator= (<span class="keyword">const</span> <a class="code" href="classtgui_1_1Grid.html">Grid</a>&amp; right);</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        <span class="keyword">static</span> <a class="code" href="classtgui_1_1Grid.html#ac74ee6eb1b8416abd617a77fd430837f">Grid::Ptr</a> create();</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;        <span class="keyword">static</span> <a class="code" href="classtgui_1_1Grid.html#ac74ee6eb1b8416abd617a77fd430837f">Grid::Ptr</a> copy(<a class="code" href="classtgui_1_1Grid.html#ae5c312f8060724b3e9eacd77a7da0f3c">Grid::ConstPtr</a> grid);</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> setSize(<span class="keyword">const</span> <a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a>&amp; size) <span class="keyword">override</span>;</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        <span class="keyword">using</span> <a class="code" href="classtgui_1_1Transformable.html#a66fe5d2a7b1477cab073984a9a3e13bc">Transformable::setSize</a>;</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;</div><div class="line"><a name="l00133"></a><span class="lineno"><a class="line" href="classtgui_1_1Grid.html#a5b7deefdd6b2aa2c20f3082938f11b54">  133</a></span>&#160;        <span class="keyword">virtual</span> sf::Vector2f <a class="code" href="classtgui_1_1Grid.html#a5b7deefdd6b2aa2c20f3082938f11b54">getSize</a>()<span class="keyword"> const override</span></div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;            <span class="keywordflow">return</span> m_realSize;</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;        }</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <span class="keyword">remove</span>(<span class="keyword">const</span> <a class="code" href="classtgui_1_1Widget.html#a388912f13898735531886bc676b14f81">Widget::Ptr</a>&amp; widget) <span class="keyword">override</span>;</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeAllWidgets() <span class="keyword">override</span>;</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;        <span class="keywordtype">void</span> addWidget(<span class="keyword">const</span> <a class="code" href="classtgui_1_1Widget.html#a388912f13898735531886bc676b14f81">Widget::Ptr</a>&amp; widget,</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;                       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>       row,</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;                       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>       column,</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;                       <span class="keyword">const</span> <a class="code" href="classtgui_1_1Borders.html">Borders</a>&amp;     borders = <a class="code" href="classtgui_1_1Borders.html">Borders</a>(0, 0, 0, 0),</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;                       <a class="code" href="classtgui_1_1Grid.html#a862e75cc54ce2fff46c9590db7f6b5e9">Alignment</a>          alignment  = Alignment::Center);</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;        <a class="code" href="classtgui_1_1Widget.html#a388912f13898735531886bc676b14f81">Widget::Ptr</a> getWidget(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> row, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> column);</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;        <span class="keywordtype">void</span> updateWidgets();</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;        <span class="keywordtype">void</span> changeWidgetBorders(<span class="keyword">const</span> <a class="code" href="classtgui_1_1Widget.html#a388912f13898735531886bc676b14f81">Widget::Ptr</a>&amp; widget, <span class="keyword">const</span> <a class="code" href="classtgui_1_1Borders.html">Borders</a>&amp; borders = <a class="code" href="classtgui_1_1Borders.html">Borders</a>(0, 0, 0, 0));</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;        <span class="keywordtype">void</span> changeWidgetAlignment(<span class="keyword">const</span> <a class="code" href="classtgui_1_1Widget.html#a388912f13898735531886bc676b14f81">Widget::Ptr</a>&amp; widget, <a class="code" href="classtgui_1_1Grid.html#a862e75cc54ce2fff46c9590db7f6b5e9">Alignment</a> alignment = Alignment::Center);</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">bool</span> mouseOnWidget(<span class="keywordtype">float</span> x, <span class="keywordtype">float</span> y) <span class="keyword">const override</span>;</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;    <span class="keyword">protected</span>:</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;        <span class="comment">// Returns the minimum size required by the grid to display correctly all widgets.</span></div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;<span class="comment"></span>        sf::Vector2f getMinSize();</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;        <span class="comment">// Reposition all the widgets.</span></div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;<span class="comment"></span>        <span class="keywordtype">void</span> updatePositionsOfAllWidgets();</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;        <span class="comment">// Makes a copy of the widget</span></div><div class="line"><a name="l00241"></a><span class="lineno"><a class="line" href="classtgui_1_1Grid.html#af473284d74f86b9396cc366b61dfab02">  241</a></span>&#160;<span class="comment"></span>        <span class="keyword">virtual</span> <a class="code" href="classtgui_1_1Widget.html#a388912f13898735531886bc676b14f81">Widget::Ptr</a> <a class="code" href="classtgui_1_1Grid.html#af473284d74f86b9396cc366b61dfab02">clone</a>()<span class="keyword"> const override</span></div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;            <span class="keywordflow">return</span> std::make_shared&lt;Grid&gt;(*this);</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;        }</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;</div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;        <span class="comment">// Draws the widget on the render target.</span></div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;<span class="comment"></span>        <span class="keyword">virtual</span> <span class="keywordtype">void</span> draw(sf::RenderTarget&amp; target, sf::RenderStates states) <span class="keyword">const override</span>;</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;</div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;    <span class="keyword">protected</span>:</div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;        std::vector&lt;std::vector&lt;Widget::Ptr&gt;&gt; m_gridWidgets;</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;        std::vector&lt;std::vector&lt;Borders&gt;&gt;     m_objBorders;</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;        std::vector&lt;std::vector&lt;Alignment&gt;&gt;   m_objAlignment;</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;        std::vector&lt;float&gt; m_rowHeight;</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;        std::vector&lt;float&gt; m_columnWidth;</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;        std::map&lt;Widget::Ptr, unsigned int&gt; m_connectedCallbacks;</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;        sf::Vector2f m_realSize; <span class="comment">// Actual size of the grid, while m_size contains the intended size</span></div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;    };</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;}</div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;<span class="preprocessor">#endif // TGUI_GRID_HPP</span></div><div class="ttc" id="namespacetgui_html"><div class="ttname"><a href="namespacetgui.html">tgui</a></div><div class="ttdoc">Namespace that contains all TGUI functions and classes. </div><div class="ttdef"><b>Definition:</b> Animation.hpp:33</div></div>
<div class="ttc" id="classtgui_1_1Grid_html_a862e75cc54ce2fff46c9590db7f6b5e9"><div class="ttname"><a href="classtgui_1_1Grid.html#a862e75cc54ce2fff46c9590db7f6b5e9">tgui::Grid::Alignment</a></div><div class="ttdeci">Alignment</div><div class="ttdoc">The alignment of the widget in its cell. </div><div class="ttdef"><b>Definition:</b> Grid.hpp:53</div></div>
<div class="ttc" id="classtgui_1_1Grid_html_ac74ee6eb1b8416abd617a77fd430837f"><div class="ttname"><a href="classtgui_1_1Grid.html#ac74ee6eb1b8416abd617a77fd430837f">tgui::Grid::Ptr</a></div><div class="ttdeci">std::shared_ptr&lt; Grid &gt; Ptr</div><div class="ttdoc">Shared widget pointer. </div><div class="ttdef"><b>Definition:</b> Grid.hpp:42</div></div>
<div class="ttc" id="classtgui_1_1Grid_html_ae5c312f8060724b3e9eacd77a7da0f3c"><div class="ttname"><a href="classtgui_1_1Grid.html#ae5c312f8060724b3e9eacd77a7da0f3c">tgui::Grid::ConstPtr</a></div><div class="ttdeci">std::shared_ptr&lt; const Grid &gt; ConstPtr</div><div class="ttdoc">Shared constant widget pointer. </div><div class="ttdef"><b>Definition:</b> Grid.hpp:43</div></div>
<div class="ttc" id="classtgui_1_1Layout2d_html"><div class="ttname"><a href="classtgui_1_1Layout2d.html">tgui::Layout2d</a></div><div class="ttdoc">Class to store the position or size of a widget. </div><div class="ttdef"><b>Definition:</b> Layout.hpp:254</div></div>
<div class="ttc" id="classtgui_1_1Grid_html_a5b7deefdd6b2aa2c20f3082938f11b54"><div class="ttname"><a href="classtgui_1_1Grid.html#a5b7deefdd6b2aa2c20f3082938f11b54">tgui::Grid::getSize</a></div><div class="ttdeci">virtual sf::Vector2f getSize() const  override</div><div class="ttdoc">Returns the size of the grid. </div><div class="ttdef"><b>Definition:</b> Grid.hpp:133</div></div>
<div class="ttc" id="classtgui_1_1Transformable_html_a66fe5d2a7b1477cab073984a9a3e13bc"><div class="ttname"><a href="classtgui_1_1Transformable.html#a66fe5d2a7b1477cab073984a9a3e13bc">tgui::Transformable::setSize</a></div><div class="ttdeci">virtual void setSize(const Layout2d &amp;size)</div><div class="ttdoc">Changes the size of the widget. </div></div>
<div class="ttc" id="classtgui_1_1Widget_html_a388912f13898735531886bc676b14f81"><div class="ttname"><a href="classtgui_1_1Widget.html#a388912f13898735531886bc676b14f81">tgui::Widget::Ptr</a></div><div class="ttdeci">std::shared_ptr&lt; Widget &gt; Ptr</div><div class="ttdoc">Shared widget pointer. </div><div class="ttdef"><b>Definition:</b> Widget.hpp:75</div></div>
<div class="ttc" id="classtgui_1_1Container_html"><div class="ttname"><a href="classtgui_1_1Container.html">tgui::Container</a></div><div class="ttdoc">Container widget. </div><div class="ttdef"><b>Definition:</b> Container.hpp:47</div></div>
<div class="ttc" id="classtgui_1_1Grid_html_af473284d74f86b9396cc366b61dfab02"><div class="ttname"><a href="classtgui_1_1Grid.html#af473284d74f86b9396cc366b61dfab02">tgui::Grid::clone</a></div><div class="ttdeci">virtual Widget::Ptr clone() const  override</div><div class="ttdoc">Makes a copy of the widget if you don&amp;#39;t know its exact type. </div><div class="ttdef"><b>Definition:</b> Grid.hpp:241</div></div>
<div class="ttc" id="classtgui_1_1Borders_html"><div class="ttname"><a href="classtgui_1_1Borders.html">tgui::Borders</a></div><div class="ttdef"><b>Definition:</b> Borders.hpp:37</div></div>
<div class="ttc" id="classtgui_1_1Grid_html"><div class="ttname"><a href="classtgui_1_1Grid.html">tgui::Grid</a></div><div class="ttdef"><b>Definition:</b> Grid.hpp:38</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- HTML footer for doxygen 1.8.10-->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Sat Nov 25 2017 17:32:41 for TGUI by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.11
</small></address>
<!-- BEGIN CUSTOM 3 -->
<!-- {% endraw %} -{{""}}-{{""}}>
</div>
{% include page_footer.ext %}
</div>
{% include footer.ext %}
<{{""}}!{{""}}-{{""}}- -->
<!-- END CUSTOM 3 -->
</body>
</html>
